﻿using System;
using System.Collections.Generic;

namespace EsempioVisitor
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Color> colors = new List<Color>();

            colors.Add(new Red());
            colors.Add(new Blu());
            colors.Add(new Blu());
            colors.Add(new Red());
            colors.Add(new Red());

            CallingVisitor callingVisitor = new CallingVisitor();
            foreach (Color color in colors)
            {
                color.Accept(callingVisitor);
            }

            CountingVisitor countingVisitor = new CountingVisitor();
            foreach (Color color in colors)
            {
                Console.WriteLine("{0}", color);
                color.Accept(countingVisitor);
            }
            Console.WriteLine("{0}", countingVisitor);
        }
    }
}
