﻿using System;

namespace EsempioVisitor
{
    public abstract class Color
    {
        public abstract void Accept(Visitor v);
    }

    public class Red : Color
    {
        public override void Accept(Visitor v)
        {
            v.Visit(this);
        }

        public void Eye()
        {
            Console.WriteLine("Red.Eye");
        }
    }

    public class Blu : Color
    {
        public override void Accept(Visitor v)
        {
            v.Visit(this);
        }

        public void Sky()
        {
            Console.WriteLine("Blu.Sky");
        }
    }
}
